'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SVGPrev = require('./svg/SVGPrev');

var _SVGPrev2 = _interopRequireDefault(_SVGPrev);

var _SVGNext = require('./svg/SVGNext');

var _SVGNext2 = _interopRequireDefault(_SVGNext);

var _SVGDir = require('./svg/SVGDir');

var _SVGDir2 = _interopRequireDefault(_SVGDir);

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _recompose = require('recompose');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _helperFunctions = require('./helperFunctions');

var _ = require('.');

var _reactSwipeable = require('react-swipeable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var interval = void 0; //implement acceleration
//write own swipeable with render props
//press for accelerated scroll
//center on select
//cure the 'freeze' bug

var useSetState = function useSetState(initialState) {
  var _useReducer = (0, _react.useReducer)(function (state, newState) {
    return (0, _extends3.default)({}, state, newState);
  }, (0, _extends3.default)({}, initialState)),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      setState = _useReducer2[1];

  return [state, setState];
};

var useSafeSetState = function useSafeSetState(initialState) {
  var _useSetState = useSetState(initialState),
      _useSetState2 = (0, _slicedToArray3.default)(_useSetState, 2),
      state = _useSetState2[0],
      setState = _useSetState2[1];

  var mountedRef = (0, _react.useRef)(false);
  (0, _react.useEffect)(function () {
    mountedRef.current = true;
    return function () {
      return mountedRef.current = false;
    };
  }, []);

  var safeSetState = function safeSetState() {
    return mountedRef.current && setState.apply(undefined, arguments);
  };
  return [state, safeSetState];
};

var Accordion = function Accordion(_ref) {
  var externalSwipeableRef = _ref.externalSwipeableRef,
      showLog = _ref.showLog,
      noX = _ref.noX,
      noY = _ref.noY,
      height = _ref.height,
      swipeableProps = _ref.swipeableProps,
      children = _ref.children,
      width = _ref.width,
      renderButton = _ref.renderButton;

  var swipeableRef = externalSwipeableRef ? externalSwipeableRef : (0, _react.useRef)(null);

  var _useSafeSetState = useSafeSetState({
    showLeft: false,
    showRight: false,
    showUp: false,
    showDown: false
  }),
      _useSafeSetState2 = (0, _slicedToArray3.default)(_useSafeSetState, 2),
      state = _useSafeSetState2[0],
      safeSetState = _useSafeSetState2[1];

  var showLeft = state.showLeft,
      showRight = state.showRight,
      showUp = state.showUp,
      showDown = state.showDown;


  (0, _react.useEffect)(function () {
    handleNavButtons();
    var containerElement = swipeableRef.current;

    if (typeof window !== 'undefined' && containerElement) {
      containerElement.addEventListener('scroll', handleNavButtons);
      window.addEventListener('resize', handleNavButtons);
    }

    return function () {
      var containerElement = swipeableRef.current;
      if (typeof window !== 'undefined' && containerElement) {
        containerElement.removeEventListener('scroll', handleNavButtons);
        window.removeEventListener('resize', handleNavButtons);
      }
    };
  }, [children]);

  var handleNavButtons = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var containerElement;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              containerElement = swipeableRef.current;
              _context.next = 3;
              return (0, _helperFunctions.delay)(250);

            case 3:
              showLog && console.log('// handleNavButtons // ', 'containerElement.scrollLeft', containerElement.scrollLeft, 'scrollWidth: ', containerElement.scrollWidth, 'clientWidth: ', containerElement.clientWidth, 'diff: ', containerElement.scrollWidth - containerElement.clientWidth, 'scrollTop: ', containerElement.scrollTop, 'scrollHeight: ', containerElement.scrollHeight, 'clientHeight: ', containerElement.clientHeight);

              if (!(containerElement.scrollLeft === 0 || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 9;
                break;
              }

              _context.next = 7;
              return safeSetState({ showLeft: false });

            case 7:
              _context.next = 12;
              break;

            case 9:
              if (!(containerElement.scrollLeft > 0)) {
                _context.next = 12;
                break;
              }

              _context.next = 12;
              return safeSetState({ showLeft: true });

            case 12:
              if (!(containerElement.scrollLeft >= containerElement.scrollWidth - containerElement.clientWidth || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 17;
                break;
              }

              _context.next = 15;
              return safeSetState({ showRight: false });

            case 15:
              _context.next = 20;
              break;

            case 17:
              if (!(containerElement.scrollWidth >= containerElement.clientWidth)) {
                _context.next = 20;
                break;
              }

              _context.next = 20;
              return safeSetState({ showRight: true });

            case 20:
              if (!(containerElement.scrollTop === 0 || containerElement.scrollHeight === containerElement.clientHeight)) {
                _context.next = 25;
                break;
              }

              _context.next = 23;
              return safeSetState({ showUp: false });

            case 23:
              _context.next = 28;
              break;

            case 25:
              if (!(containerElement.scrollTop > 0)) {
                _context.next = 28;
                break;
              }

              _context.next = 28;
              return safeSetState({ showUp: true });

            case 28:
              if (!(containerElement.scrollTop >= containerElement.scrollHeight - containerElement.clientHeight || containerElement.scrollHeight === containerElement.clientHeight)) {
                _context.next = 33;
                break;
              }

              _context.next = 31;
              return safeSetState({ showDown: false });

            case 31:
              _context.next = 36;
              break;

            case 33:
              if (!(containerElement.scrollTop === 0)) {
                _context.next = 36;
                break;
              }

              _context.next = 36;
              return safeSetState({ showDown: true });

            case 36:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function handleNavButtons() {
      return _ref2.apply(this, arguments);
    };
  }();

  var startScroll = function startScroll(e, direction) {
    e.stopPropagation();
    clearInterval(interval);

    var containerElement = swipeableRef.current;

    if (containerElement) {
      interval = setInterval(function () {
        switch (direction) {
          case 'Left':
            containerElement.scrollLeft -= 20;
            break;

          case 'Right':
            containerElement.scrollLeft += 20;
            break;

          case 'Up':
            containerElement.scrollTop += -20;
            break;

          case 'Down':
            containerElement.scrollTop += 20;
            break;
        }
      }, 50);
    }
  };

  var scroll = function scroll(e, direction) {
    e.stopPropagation();

    var containerElement = swipeableRef.current;
    if (containerElement) {
      switch (direction) {
        case 'Left':
          containerElement.scrollLeft -= 10;
          break;
        case 'Right':
          containerElement.scrollLeft += 10;
          break;
        case 'Up':
          containerElement.scrollTop -= 10;
          break;
        case 'Down':
          containerElement.scrollTop += 10;
          break;
      }
    }
  };
  var endScroll = function endScroll(e) {
    e.stopPropagation();
    clearInterval(interval);
  };
  var renderNav = function renderNav(direction) {
    var containerElement = swipeableRef.current;

    showLog && console.log('containerElement: ', containerElement);

    var autoHeight = containerElement && containerElement.clientHeight;
    var autoWidth = 30;
    var vertWidth = containerElement && containerElement.clientWidth;
    var vertHeight = 30;

    var SVGProps = {
      fill: '#555',
      size: width ? width : 18
    };
    var renderIcon = function renderIcon(_ref3) {
      var direction = _ref3.direction,
          props = (0, _objectWithoutProperties3.default)(_ref3, ['direction']);

      switch (direction) {
        case 'Right':
          return _react2.default.createElement(_SVGNext2.default, (0, _extends3.default)({}, SVGProps, { dir: direction }, props));
        case 'Left':
          return _react2.default.createElement(_SVGPrev2.default, (0, _extends3.default)({}, SVGProps, { dir: direction }, props));
        case 'Up':
          return _react2.default.createElement(_SVGExpandLess2.default, (0, _extends3.default)({}, SVGProps, props));
        case 'Down':
          return _react2.default.createElement(_SVGExpandMore2.default, (0, _extends3.default)({}, SVGProps, props));
      }
    };
    var inProp = function inProp(_ref4) {
      var direction = _ref4.direction;

      switch (direction) {
        case 'Right':
          return showRight;
        case 'Left':
          return showLeft;
        case 'Up':
          return showUp;
        case 'Down':
          return showDown;
      }
    };
    var getStyle = function getStyle(_ref5) {
      var direction = _ref5.direction;

      switch (direction) {
        case 'Right':
          return {
            top: 0,
            width: width ? width : autoWidth,
            height: height ? height : autoHeight,
            right: 0
          };
        case 'Left':
          return {
            top: 0,
            width: width ? width : autoWidth,
            height: height ? height : autoHeight
          };
        case 'Up':
          return {
            top: 0,
            width: width ? width : vertWidth,
            height: height ? height : vertHeight
          };
        case 'Down':
          return {
            bottom: 0,
            width: width ? width : vertWidth,
            height: height ? height : vertHeight
          };
      }
    };

    return _react2.default.createElement(
      _RTGTransition2.default,
      { in: inProp({ direction: direction }) },
      function (_ref6) {
        var transitionStyle = _ref6.style;

        var getButtonProps = function getButtonProps() {
          var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

          var style = _ref7.style,
              colors = _ref7.colors,
              props = (0, _objectWithoutProperties3.default)(_ref7, ['style', 'colors']);
          return {
            onMouseDown: function onMouseDown(e) {
              return startScroll(e, direction);
            },
            onMouseUp: endScroll,
            onTouchStart: function onTouchStart(e) {
              return startScroll(e, direction);
            },
            onTouchEnd: endScroll,
            className: 'accordion_navbutton accordion__navbutton--' + direction,
            colors: colors ? colors : _.buttonStyles.violet,
            style: (0, _extends3.default)({}, transitionStyle, {
              padding: 0,
              position: 'absolute'
            }, getStyle({ direction: direction }), style)
          };
        };
        return renderButton ? renderButton({ getButtonProps: getButtonProps, renderIcon: renderIcon, direction: direction }) : _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({}, getButtonProps({
            colors: 'smoke',
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center'
          })),
          renderIcon({ direction: direction, fill: '#555' })
        );
      }
    );
  };

  var handlers = (0, _reactSwipeable.useSwipeable)({
    trackMouse: true,
    preventDefaultTouchmoveEvent: true,
    onSwiping: function onSwiping(e) {
      return scroll(e.event, e.dir);
    }
  });

  return typeof window !== 'undefined' && _react2.default.createElement(
    _react2.default.Fragment,
    null,
    !noX && renderNav('Left'),
    !noY && renderNav('Up'),
    typeof children === 'function' ? children({ handlers: handlers, swipeableRef: swipeableRef }) : _react2.default.createElement(
      'div',
      (0, _extends3.default)({
        //          ...handlers,
        ref: swipeableRef
      }, swipeableProps),
      children
    ),
    !noX && renderNav('Right'),
    !noY && renderNav('Down')
  );
};

Accordion.defaultProps = {
  noX: false,
  noY: false,
  showLog: false
};

Accordion.propTypes = {
  containerClass: _propTypes2.default.string,

  width: _propTypes2.default.number
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['children']));

exports.default = enhance(Accordion);