'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Card = function Card(_ref) {
  var style = _ref.style,
      className = _ref.className,
      _onClick = _ref.onClick,
      children = _ref.children,
      _ref$theme = _ref.theme,
      theme = _ref$theme === undefined ? _defaultStyles.cardStyles.none : _ref$theme;
  var baseContainerStyle = theme.baseContainerStyle,
      baseImageStyle = theme.baseImageStyle,
      baseSternStyle = theme.baseSternStyle,
      baseStarboardStyle = theme.baseStarboardStyle,
      baseTitleStyle = theme.baseTitleStyle,
      baseSubtitleStyle = theme.baseSubtitleStyle;

  var getContainerProps = function getContainerProps() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseContainerStyle, style),
      className: className ? className + ' card__container' : 'card__container',
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      }
    }, props);
  };

  var getImageProps = function getImageProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick2 = _ref2.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseImageStyle, style),
      className: className ? className + ' card__image' : 'card__image',
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getTitleProps = function getTitleProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref3.className,
        style = _ref3.style,
        _onClick3 = _ref3.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['className', 'style', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseTitleStyle, style),
      className: className ? className + ' card__title' : 'card__title',
      onClick: function onClick(e) {
        for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }

        e.stopPropagation();
        _onClick3 && _onClick3.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getSubtitleProps = function getSubtitleProps() {
    var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref4.className,
        style = _ref4.style,
        _onClick4 = _ref4.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref4, ['className', 'style', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseSubtitleStyle, style),
      className: className ? className + ' card__subtitle' : 'card__subtitle',
      onClick: function onClick(e) {
        for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          args[_key4 - 1] = arguments[_key4];
        }

        e.stopPropagation();
        _onClick4 && _onClick4.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getSternProps = function getSternProps() {
    var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref5.className,
        style = _ref5.style,
        _onClick5 = _ref5.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref5, ['className', 'style', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseSternStyle, style),
      className: className ? className + ' card__stern' : 'card__stern',
      onClick: function onClick(e) {
        for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
          args[_key5 - 1] = arguments[_key5];
        }

        e.stopPropagation();
        _onClick5 && _onClick5.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getStarboardProps = function getStarboardProps() {
    var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref6.className,
        style = _ref6.style,
        _onClick6 = _ref6.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref6, ['className', 'style', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseStarboardStyle, style),
      className: className ? className + ' card__starboard' : 'card__starboard',
      onClick: function onClick(e) {
        for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
          args[_key6 - 1] = arguments[_key6];
        }

        e.stopPropagation();
        _onClick6 && _onClick6.apply(undefined, [e].concat(args));
      }
    }, props);
  };

  //const getImageProps = ({...args, style}) => getGenericProps({baseClassName: `card_imagewrapper`, style: {...style, ...baseImageStyle}, ...args})

  return _react2.default.createElement(
    'div',
    (0, _extends3.default)({}, getContainerProps()),
    children({
      getImageProps: getImageProps,
      getTitleProps: getTitleProps,
      getStarboardProps: getStarboardProps,
      getSternProps: getSternProps,
      getSubtitleProps: getSubtitleProps
    })
  );
};

exports.default = Card;