'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _RTGFade = require('./RTGFade');

var _RTGFade2 = _interopRequireDefault(_RTGFade);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iconSize = '50';
var scrollOptions = { block: 'start', behavior: 'smooth' };

var ScrollNav = function (_Component) {
  (0, _inherits3.default)(ScrollNav, _Component);

  function ScrollNav() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ScrollNav);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ScrollNav.__proto__ || (0, _getPrototypeOf2.default)(ScrollNav)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showScrollNav: false
    }, _this.handleScroll = function () {
      var _this$props = _this.props,
          containerId = _this$props.containerId,
          children = _this$props.children;

      var container = containerId ? document.getElementById(containerId) : children.ref ? children.ref.current : null;
      if (container.offsetTop < window.scrollY && container.offsetTop + container.offsetHeight > window.scrollY + window.screen.height) {
        _this.setState((0, _extends3.default)({}, _this.state, { showScrollNav: true }));
      }
      if (container.offsetTop > window.scrollY || container.offsetTop + container.offsetHeight < window.scrollY + window.screen.height) {
        _this.setState((0, _extends3.default)({}, _this.state, { showScrollNav: false }));
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ScrollNav, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window ? window.addEventListener('scroll', this.handleScroll) : null;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('scroll', this.handleScroll);
    }
  }, {
    key: 'render',
    value: function render() {
      var showScrollNav = this.state.showScrollNav,
          _props = this.props,
          containerId = _props.containerId,
          children = _props.children;

      var sharedStyle = {
        position: 'fixed',
        left: '2rem'
      };
      var container = containerId ? document.getElementById(containerId) : children.ref ? children.ref.current : null;
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _RTGFade2.default,
          { in: showScrollNav },
          function (_ref2) {
            var transitionStyle = _ref2.style;
            return _react2.default.createElement(
              _Button2.default,
              {
                style: (0, _extends3.default)({}, sharedStyle, transitionStyle, { top: '2rem' }),
                onClick: function onClick() {
                  return container.scrollIntoView(scrollOptions);
                },
                className: (0, _helperFunctions.flippyClass)(showScrollNav, 'elevator', 'show', 'hide') + ' ' + (0, _helperFunctions.flippyClass)(showScrollNav, 'elevator__top', 'show', 'hide')
              },
              _react2.default.createElement(_SVGExpandLess2.default, { size: iconSize })
            );
          }
        ),
        children && children,
        _react2.default.createElement(
          _RTGFade2.default,
          { in: showScrollNav },
          function (_ref3) {
            var transitionStyle = _ref3.style;
            return _react2.default.createElement(
              _Button2.default,
              {
                style: (0, _extends3.default)({}, sharedStyle, transitionStyle, { bottom: '2rem' }),
                onClick: function onClick() {
                  return container.scrollIntoView((0, _extends3.default)({}, scrollOptions, {
                    block: 'end'
                  }));
                },
                className: (0, _helperFunctions.flippyClass)(showScrollNav, 'elevator', 'show', 'hide') + ' ' + (0, _helperFunctions.flippyClass)(showScrollNav, 'elevator__bottom', 'show', 'hide')
              },
              _react2.default.createElement(_SVGExpandMore2.default, { size: iconSize })
            );
          }
        )
      );
    }
  }]);
  return ScrollNav;
}(_react.Component);

exports.default = ScrollNav;