'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ErrorMessage = function ErrorMessage(_ref) {
  var code = _ref.code;

  var getMessage = function getMessage() {
    switch (code) {
      case 'auth/user-not-found':
        return React.createElement(
          'div',
          { 'data-testid': 'errormessage-invalidemailorpassword', className: 'errormessage__item' },
          '`error.invalidemailorpassword`'
        );
      case 'auth/wrong-password':
        return React.createElement(
          'div',
          { 'data-testid': 'errormessage-invalidemailorpassword', className: 'errormessage__item' },
          '`error.invalidemailorpassword`'
        );
      case 'auth/invalid-email':
        return React.createElement(
          'div',
          { 'data-testid': 'errormessage-emailisbadlyformatted', className: 'errormessage__item' },
          '`error.emailisbadlyformatted`'
        );
      default:
        return 'No error code message.';
    }
  };
  return React.createElement(
    'div',
    { className: 'errormessage__container' },
    getMessage()
  );
};

ErrorMessage.propTypes = {
  code: _propTypes2.default.string.isRequired
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['code']));

exports.default = enhance(ErrorMessage);