'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useKBListener = undefined;

var _react = require('react');

var useKBListener = exports.useKBListener = function useKBListener(_ref) {
  var keyCodes = _ref.keyCodes;

  var handleKBInput = function handleKBInput(e) {
    keyCodes.forEach(function (keyCode) {
      if (e.keyCode === keyCode[0]) {
        keyCode[1]();
      }
    });
  };
  (0, _react.useEffect)(function () {
    if (typeof document !== 'undefined') {
      document.addEventListener('keydown', handleKBInput);
    }
    return function () {
      document.removeEventListener('keydown', handleKBInput);
    };
  });
};