'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helperFunctions = require('../utilities/helperFunctions');

var _recompose = require('recompose');

var _ListItem = require('./ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var List = function List(_ref) {
  var items = _ref.items,
      show = _ref.show,
      page = _ref.page,
      props = (0, _objectWithoutProperties3.default)(_ref, ['items', 'show', 'page']);

  return _react2.default.createElement(
    'div',
    {
      className: (0, _helperFunctions.flippyClass)(show, 'list', 'show', 'hide') + ' ' + (0, _helperFunctions.flippyClass)(show, page + '__list', 'show', 'hide')
    },
    items.map(function (item, i) {
      return _react2.default.createElement(_ListItem2.default, (0, _extends3.default)({ key: i, item: item, page: page }, props));
    })
  );
};

var enhance = (0, _recompose.compose)((0, _recompose.propTypes)({
  items: _propTypes2.default.array.isRequired
}), (0, _recompose.defaultProps)({
  page: 'default'
}), _recompose.pure);

exports.default = enhance(List);