'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ListItem = function ListItem(_ref) {
  var item = _ref.item,
      renderDeck = _ref.renderDeck,
      renderPort = _ref.renderPort,
      renderBow = _ref.renderBow,
      renderStarboard = _ref.renderStarboard,
      renderStern = _ref.renderStern,
      page = _ref.page;

  return _react2.default.createElement(
    'div',
    {
      style: {
        display: 'grid'
      },
      className: 'list__item ' + page + '__list__item'
    },
    _react2.default.createElement(
      'div',
      { gridArea: 'bow', className: 'list__bow ' + page + '__list__bow' },
      renderBow(item)
    ),
    _react2.default.createElement(
      'div',
      { gridArea: 'deck', className: 'list__deck ' + page + '__list__deck' },
      renderDeck(item)
    ),
    _react2.default.createElement(
      'div',
      { gridArea: 'port', className: 'list__port ' + page + '__list__port' },
      renderPort(item)
    ),
    _react2.default.createElement(
      'div',
      { gridArea: 'starboard', className: 'list__starboard ' + page + '__list__starboard' },
      renderStarboard(item)
    ),
    _react2.default.createElement(
      'div',
      { gridArea: 'stern', className: 'list__stern ' + page + '__list__stern' },
      renderStern(item)
    )
  );
};

var enhance = (0, _recompose.compose)(propTypes({
  item: _propTypes2.default.object.isRequired
}), _recompose.pure);

exports.default = enhance(ListItem);