'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _CreateUserWithEmailAndPasswordForm = require('./CreateUserWithEmailAndPasswordForm');

var _CreateUserWithEmailAndPasswordForm2 = _interopRequireDefault(_CreateUserWithEmailAndPasswordForm);

var _SinglePageModal = require('./SinglePageModal');

var _SinglePageModal2 = _interopRequireDefault(_SinglePageModal);

var _SignInModal = require('./SignInModal');

var _SignInModal2 = _interopRequireDefault(_SignInModal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RegisterUserAccountModal = function RegisterUserAccountModal(_ref) {
  var demoModeIsOn = _ref.demoModeIsOn,
      labels = _ref.labels,
      handleCreateUserWithEmailAndPassword = _ref.handleCreateUserWithEmailAndPassword,
      props = (0, _objectWithoutProperties3.default)(_ref, ['demoModeIsOn', 'labels', 'handleCreateUserWithEmailAndPassword']);

  console.log(props);
  return _react2.default.createElement(_SinglePageModal2.default, (0, _extends3.default)({
    style: {
      width: '30rem'
    },
    demoModeIsOn: demoModeIsOn,
    containerPropsAppend: {
      className: 'registeraccountmodal__container'
    },
    renderTrigger: function renderTrigger(_ref2) {
      var getTriggerProps = _ref2.getTriggerProps;
      return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({}, getTriggerProps(), {
          dataTestId: 'signinmodal_registeraccountmodal-trigger',
          type: 'small'
        }),
        labels.trigger
      );
    },
    renderHeader: function renderHeader(_ref3) {
      var getHeaderProps = _ref3.getHeaderProps;
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getHeaderProps()),
        labels.header
      );
    },
    renderBody: function renderBody(_ref4) {
      var getBodyProps = _ref4.getBodyProps;
      return _react2.default.createElement(
        'div',
        getBodyProps(),
        _react2.default.createElement(_CreateUserWithEmailAndPasswordForm2.default, { labels: labels, handleCreateUserWithEmailAndPassword: handleCreateUserWithEmailAndPassword }),
        _react2.default.createElement(_SignInModal2.default, {})
      );
    }
  }, props));
};

RegisterUserAccountModal.propTypes = {};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  handleCreateUserWithEmailAndPassword: function handleCreateUserWithEmailAndPassword(_ref5) {
    var email = _ref5.email,
        password = _ref5.password;
    return console.log('handleCreateUserWithEmailAndPassword', email, password);
  },
  labels: {
    header: 'Register a new account',
    trigger: 'register',

    submit: 'submit',
    email: 'email',
    emailRequired: 'emailRequired',
    emailInvalid: 'emailInvalid',
    password: 'password',
    passwordRequired: 'passwordRequired',
    passwordMinLength: 'passwordMinLength',
    passwordConfirmation: 'passwordConfirmation',
    passwordConfirmationRequired: 'passwordConfirmationRequired',
    passwordConfirmationMismatch: 'passwordConfirmationMismatch'
  }
}));

exports.default = enhance(RegisterUserAccountModal);