'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectMany = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _CTCPopover = require('./CTCPopover');

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _defaultStyles = require('./defaultStyles');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import { Button } from './Button'

var SelectMany = function SelectMany(_ref) {
  var _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === undefined ? function (x) {
    return console.log(x);
  } : _ref$onChange,
      _ref$buttonType = _ref.buttonType,
      buttonType = _ref$buttonType === undefined ? 'select--default' : _ref$buttonType,
      _ref$renderCurrentOpt = _ref.renderCurrentOption,
      renderCurrentOption = _ref$renderCurrentOpt === undefined ? function (option) {
    return option.label;
  } : _ref$renderCurrentOpt,
      sortingFunction = _ref.sortingFunction,
      _ref$showUnselectedOn = _ref.showUnselectedOnly,
      showUnselectedOnly = _ref$showUnselectedOn === undefined ? false : _ref$showUnselectedOn,
      children = _ref.children,
      renderTrigger = _ref.renderTrigger,
      _ref$initialOptions = _ref.initialOptions,
      initialOptions = _ref$initialOptions === undefined ? [] : _ref$initialOptions,
      props = (0, _objectWithoutProperties3.default)(_ref, ['onChange', 'buttonType', 'renderCurrentOption', 'sortingFunction', 'showUnselectedOnly', 'children', 'renderTrigger', 'initialOptions']);

  function init(initialOptions) {
    return { currentOptions: initialOptions };
  }

  var reducer = function reducer(_ref2, action) {
    var currentOptions = _ref2.currentOptions;

    console.log((0, _stringify2.default)(action));
    var updatedState = void 0;
    switch (action.type) {
      case 'add':
        updatedState = {
          currentOptions: sortingFunction ? [].concat((0, _toConsumableArray3.default)(currentOptions), [action.payload.option]).sort(sortingFunction) : [].concat((0, _toConsumableArray3.default)(currentOptions), [action.payload.option])
        };
        onChange(updatedState.currentOptions);
        return updatedState;
      case 'remove':
        updatedState = {
          currentOptions: currentOptions.filter(function (currentOption) {
            return currentOption.value !== action.payload.option.value;
          })
        };
        onChange(updatedState.currentOptions);
        return updatedState;
      case 'clear':
        updatedState = init(action.payload.options);
        onChange(updatedState.currentOptions);
        return updatedState;
      default:
        throw new Error();
    }
  };

  var _useReducer = (0, _react.useReducer)(reducer, initialOptions, init),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var currentOptions = state.currentOptions;


  var isActive = function isActive(option) {
    return currentOptions.some(function (currentOption) {
      return currentOption.value === option.value;
    });
  };
  var getChildProps = function getChildProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref3.className,
        style = _ref3.style,
        _onClick = _ref3.onClick,
        option = _ref3.option,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['className', 'style', 'onClick', 'option']);

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        e.nativeEvent.stopImmediatePropagation();
        if (isActive(option)) {
          dispatch({ type: 'remove', payload: { option: option } });
        } else {
          dispatch({ type: 'add', payload: { option: option } });
        }

        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyClass)(isActive(option), 'selectmany__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(option), className, 'active', 'inactive') : ''),
      style: style
    }, props);
  };

  var handleRenderTrigger = function handleRenderTrigger(_ref4) {
    var isOn = _ref4.isOn,
        _getTriggerProps = _ref4.getTriggerProps;
    return renderTrigger ? renderTrigger({
      currentOptions: currentOptions,
      isOn: isOn,
      getTriggerProps: function getTriggerProps() {
        var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var _ref5$className = _ref5.className,
            className = _ref5$className === undefined ? '' : _ref5$className,
            props = (0, _objectWithoutProperties3.default)(_ref5, ['className']);
        return _getTriggerProps((0, _extends3.default)({
          className: 'selectmany__trigger ' + className
        }, props));
      }
    }) : _react2.default.createElement(
      _Button2.default,
      {
        type: 'caretdown',
        isOn: isOn,
        colors: _defaultStyles.buttonStyles.mild
      },
      function (_ref6) {
        var getButtonProps = _ref6.getButtonProps,
            icon = _ref6.icon;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps((0, _extends3.default)({}, _getTriggerProps({
            className: 'selectmany__trigger',
            style: {
              display: 'flex',
              justifyContent: 'space-between'
            }
          })))),
          _react2.default.createElement(
            'div',
            {
              className: 'selectmany__options',
              style: {
                display: 'flex',
                flexWrap: 'wrap'
              }
            },
            currentOptions.length > 0 ? currentOptions.map(function (currentOption, i) {
              return _react2.default.createElement(
                'div',
                {
                  key: '' + currentOption.value + i,
                  className: 'selectmany__option',
                  style: {
                    display: 'flex',
                    background: '#f3f3f3',
                    borderRadius: '0.25rem',
                    margin: '0.25rem 0.375rem'
                  }
                },
                _react2.default.createElement(
                  'div',
                  {
                    className: 'selectmany__option__label',
                    style: {
                      display: 'flex',
                      alignItems: 'center',
                      color: '#2b2b2b',
                      padding: '0.25rem 0.375rem'
                    }
                  },
                  renderCurrentOption(currentOption)
                ),
                _react2.default.createElement(_Button2.default, {
                  className: 'selectmany__option__remove',
                  type: 'cancel',
                  colors: 'darkhighlight',
                  onClick: function onClick(e) {
                    e.stopPropagation();
                    e.nativeEvent.stopImmediatePropagation();
                    dispatch({ type: 'remove', payload: { option: currentOption } });
                  }
                })
              );
            }) : _react2.default.createElement(
              'div',
              {
                className: 'selectmany__guide',
                style: {
                  display: 'flex',
                  borderRadius: '0.25rem',
                  margin: '0.25rem 0.375rem'
                }
              },
              'select one...'
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'selectmany__removeall', style: { display: 'flex' } },
            currentOptions.length > 0 && _react2.default.createElement(_Button2.default, {
              type: 'cancel',
              colors: _defaultStyles.buttonStyles.redden,
              onClick: function onClick(e) {
                e.stopPropagation();
                e.nativeEvent.stopImmediatePropagation();
                dispatch({ type: 'clear', payload: { options: [] } });
              }
            }),
            _react2.default.createElement(
              'div',
              {
                className: 'selectmany__caret',
                style: { padding: '0.5rem 0.75rem' }
              },
              icon
            )
          )
        );
      }
    );
  };
  return _react2.default.createElement(
    _CTCPopover2.default,
    (0, _extends3.default)({
      renderTrigger: handleRenderTrigger
    }, props),
    function (_ref7) {
      var getChildrenProps = _ref7.getChildrenProps,
          toggleIsOn = _ref7.toggleIsOn;
      return typeof children === 'function' ? children({
        getChildProps: getChildProps,
        getChildrenProps: getChildrenProps,
        toggleIsOn: toggleIsOn,
        currentOptions: currentOptions
      }) : _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getChildrenProps({ style: { zIndex: 1 } })),
        children.filter(function (option) {
          if (showUnselectedOnly) {
            if (!currentOptions.some(function (currentOption) {
              return currentOption.value === option.value;
            })) {
              return option;
            }
          } else {
            return option;
          }
        }).map(function (option) {
          return _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getChildProps({ option: option }), {
              colors: _defaultStyles.buttonStyles.monochrome,
              isOn: currentOptions.some(function (currentOption) {
                return currentOption.value === option.value;
              }),
              key: option.value
            }),
            option.label
          );
        })
      );
    }
  );
};

exports.SelectMany = SelectMany;
exports.default = SelectMany;