'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helperFunctions = require('./helperFunctions');

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectOpen = function SelectOpen(_ref) {
  var className = _ref.className,
      options = _ref.options,
      renderOption = _ref.renderOption,
      onChange = _ref.onChange,
      defaultCurrentOption = _ref.defaultCurrentOption;

  var _useReducer = (0, _react.useReducer)(function (state, newState) {
    return (0, _extends3.default)({}, state, newState);
  }, {
    currentOption: defaultCurrentOption ? defaultCurrentOption : options[0]
  }),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      setState = _useReducer2[1];

  var setCurrentOption = function setCurrentOption(option) {
    return setState({ currentOption: option });
  };
  var currentOption = state.currentOption;


  var isActive = function isActive(option) {
    return option.value === currentOption.value;
  };
  var _getOptionProps = function _getOptionProps(_ref2) {
    var _onClick = _ref2.onClick,
        style = _ref2.style,
        className = _ref2.className,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['onClick', 'style', 'className', 'option']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        setCurrentOption(option);
        onChange(option);
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyMultiBase)(isActive(option), ['selectopen__option', className], 'active', 'inactive'),
      style: style
    }, props);
  };
  return _react2.default.createElement(
    'div',
    {
      className: className ? 'selectopen__container' : 'selectopen__container ' + className
    },
    options.map(function (option) {
      return renderOption({
        option: option,
        isActive: isActive(option),
        getOptionProps: function getOptionProps(props) {
          return _getOptionProps((0, _extends3.default)({ option: option }, props));
        }
      });
    })
  );
};

SelectOpen.propTypes = {
  options: _propTypes2.default.array.isRequired
};
SelectOpen.defaultProps = {
  onChange: function onChange() {
    return null;
  }
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['options']));
exports.default = enhance(SelectOpen);