'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formik = require('formik');

var _recompose = require('recompose');

var _Form = require('./Form');

var _Form2 = _interopRequireDefault(_Form);

var _yup = require('yup');

var Yup = _interopRequireWildcard(_yup);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SendEmailVerificationForm = function SendEmailVerificationForm(props) {
  var labels = props.labels;

  return _react2.default.createElement(
    _Form2.default,
    (0, _extends3.default)({}, props),
    function (_ref) {
      var renderTextInputSocket = _ref.renderTextInputSocket,
          renderSubmitButton = _ref.renderSubmitButton;
      return _react2.default.createElement(
        _react.Fragment,
        null,
        renderTextInputSocket({ label: labels.email, type: 'email' }),
        renderSubmitButton({ label: labels.submit })
      );
    }
  );
};

SendEmailVerificationForm.propTypes = {
  //toggleModal: PropTypes.func.isRequired,
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  handleSendEmailVerificationForm: function handleSendEmailVerificationForm() {
    return console.log('handleSendEmailVerificationForm');
  },
  labels: {
    email: 'enter your email',
    submit: 'submit'
  }
}), (0, _recompose.withProps)({
  email: ''
}), (0, _formik.withFormik)({
  mapPropsToValues: function mapPropsToValues(_ref2) {
    var email = _ref2.email;
    return {
      email: email
    };
  },
  validationSchema: function validationSchema(_ref3) {
    var labels = _ref3.labels;

    return Yup.object().shape({
      email: Yup.string().email(labels.emailInvalid).required(labels.emailRequired)
    });
  },
  handleSubmit: function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(values, _ref4) {
      var handleSendEmailVerificationForm = _ref4.props.handleSendEmailVerificationForm,
          setSubmitting = _ref4.setSubmitting,
          setFieldError = _ref4.setFieldError;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;

              console.log('Submit', (0, _stringify2.default)(values));
              _context.next = 4;
              return handleSendEmailVerificationForm(values);

            case 4:
              _context.next = 11;
              break;

            case 6:
              _context.prev = 6;
              _context.t0 = _context['catch'](0);

              console.error(_context.t0);
              _context.next = 11;
              return setFieldError('firebase', _context.t0.message);

            case 11:
              _context.next = 13;
              return setSubmitting(false);

            case 13:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined, [[0, 6]]);
    }));

    function handleSubmit(_x, _x2) {
      return _ref5.apply(this, arguments);
    }

    return handleSubmit;
  }()
}));

exports.default = enhance(SendEmailVerificationForm);