'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _ErrorMessage = require('./ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SignInForm = function SignInForm(_ref) {
  var callback = _ref.callback,
      email = _ref.email,
      _ref$labels = _ref.labels,
      labels = _ref$labels === undefined ? {
    email: 'Email',
    password: 'Password',
    submit: 'Submit'
  } : _ref$labels,
      handleEmail = _ref.handleEmail,
      password = _ref.password,
      handlePassword = _ref.handlePassword,
      hasError = _ref.hasError,
      handleHasError = _ref.handleHasError,
      error = _ref.error,
      handleError = _ref.handleError,
      handleSignInWithEmailAndPassword = _ref.handleSignInWithEmailAndPassword;

  var handleSubmit = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(e) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              console.log('submit');
              e.preventDefault();
              _context.prev = 2;
              _context.next = 5;
              return handleSignInWithEmailAndPassword(email, password);

            case 5:
              _context.next = 7;
              return callback();

            case 7:
              _context.next = 9;
              return handleHasError(false);

            case 9:
              _context.next = 16;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context['catch'](2);

              handleError(_context.t0);
              handleHasError(true);
              console.error(_context.t0);

            case 16:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined, [[2, 11]]);
    }));

    return function handleSubmit(_x) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onChangeEmail = function onChangeEmail(_ref3) {
    var value = _ref3.target.value;

    handleEmail(value);
  };
  var onChangePassword = function onChangePassword(_ref4) {
    var value = _ref4.target.value;

    handlePassword(value);
  };

  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement(
      'form',
      { className: 'signinform', onSubmit: handleSubmit },
      _react2.default.createElement(
        'div',
        { className: 'form__socket' },
        _react2.default.createElement('input', {
          'data-testid': 'signinform-email',
          type: 'text',
          value: email,
          onChange: onChangeEmail,
          required: true
        }),
        _react2.default.createElement(
          'label',
          null,
          labels.email
        ),
        _react2.default.createElement('span', { className: 'bar' })
      ),
      _react2.default.createElement(
        'div',
        { className: 'form__socket' },
        _react2.default.createElement('input', {
          type: 'text',
          'data-testid': 'signinform-password',
          value: password,
          onChange: onChangePassword,
          required: true
        }),
        _react2.default.createElement(
          'label',
          null,
          labels.password
        ),
        _react2.default.createElement('span', { className: 'bar' })
      ),
      hasError && _react2.default.createElement(_ErrorMessage2.default, { code: error.code }),
      _react2.default.createElement(
        _Button2.default,
        {
          type: 'signin',
          dataTestId: 'signinform-submitbutton',
          onClick: function onClick(e) {
            console.log('clicked submit');
            handleSubmit(e);
          }
        },
        labels.submit
      ),
      ' ',
      _react2.default.createElement('input', {
        type: 'submit',
        style: { visibility: 'hidden', height: '0', position: 'fixed', left: '-9999' }
      })
    )
  );
};

SignInForm.propTypes = {
  //toggleModal: PropTypes.func.isRequired,
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('email', 'handleEmail', ''), (0, _recompose.withState)('password', 'handlePassword', ''), (0, _recompose.withState)('hasError', 'handleHasError', false), (0, _recompose.withState)('error', 'handleError', ''));

exports.default = enhance(SignInForm);