'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _SignInWithEmailAndPasswordForm = require('./SignInWithEmailAndPasswordForm');

var _SignInWithEmailAndPasswordForm2 = _interopRequireDefault(_SignInWithEmailAndPasswordForm);

var _RegisterUserAccountModal = require('./RegisterUserAccountModal');

var _RegisterUserAccountModal2 = _interopRequireDefault(_RegisterUserAccountModal);

var _SinglePageModal = require('./SinglePageModal');

var _SinglePageModal2 = _interopRequireDefault(_SinglePageModal);

var _SendPasswordResetEmailModal = require('./SendPasswordResetEmailModal');

var _SendPasswordResetEmailModal2 = _interopRequireDefault(_SendPasswordResetEmailModal);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _LoginViaThirdParty = require('./LoginViaThirdParty');

var _LoginViaThirdParty2 = _interopRequireDefault(_LoginViaThirdParty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SignInModal = function SignInModal(_ref) {
  var onSignedIn = _ref.onSignedIn,
      handleSignInWithEmailAndPassword = _ref.handleSignInWithEmailAndPassword,
      handleCreateUserWithEmailAndPassword = _ref.handleCreateUserWithEmailAndPassword,
      handleSendPasswordResetEmail = _ref.handleSendPasswordResetEmail,
      handleSignInWithFacebook = _ref.handleSignInWithFacebook,
      handleSignInWithGoogle = _ref.handleSignInWithGoogle,
      labels = _ref.labels,
      props = (0, _objectWithoutProperties3.default)(_ref, ['onSignedIn', 'handleSignInWithEmailAndPassword', 'handleCreateUserWithEmailAndPassword', 'handleSendPasswordResetEmail', 'handleSignInWithFacebook', 'handleSignInWithGoogle', 'labels']);

  return _react2.default.createElement(_SinglePageModal2.default, (0, _extends3.default)({
    style: { width: '30rem' },
    containerPropsAppend: { className: 'signinmodal__container' },
    dataTestId: 'signinmodal-container',
    renderTrigger: function renderTrigger(_ref2) {
      var getTriggerProps = _ref2.getTriggerProps;
      return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({}, getTriggerProps()),
        'Sign in'
      );
    },
    renderHeader: function renderHeader(_ref3) {
      var getHeaderProps = _ref3.getHeaderProps;
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getHeaderProps()),
        'Sign in header'
      );
    },
    renderBody: function renderBody(_ref4) {
      var getBodyProps = _ref4.getBodyProps;
      return _react2.default.createElement(
        'div',
        getBodyProps(),
        _react2.default.createElement(_SignInWithEmailAndPasswordForm2.default, {
          handleSignInWithEmailAndPassword: handleSignInWithEmailAndPassword,
          labels: labels.SignInWithEmailAndPasswordForm
        }),
        _react2.default.createElement(
          'div',
          {
            className: 'signinmodal__buttons--auxiliary',
            style: { display: 'flex', justifyContent: 'center' }
          },
          _react2.default.createElement(_RegisterUserAccountModal2.default, {
            labels: labels.registeruseraccountmodal,
            handleCreateUserWithEmailAndPassword: handleCreateUserWithEmailAndPassword,
            renderTrigger: function renderTrigger(_ref5) {
              var getTriggerProps = _ref5.getTriggerProps;
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends3.default)({}, getTriggerProps({
                  //onClick: () => setModalIsOpenTo(false),
                }), {
                  dataTestId: 'signinmodal-registeruseraccountmodal-trigger',
                  colors: 'link'
                }),
                labels.registeruseraccountmodal.subTrigger
              );
            }
          }),
          _react2.default.createElement(_SendPasswordResetEmailModal2.default, {
            labels: labels.passwordrecoverymodal,
            handleSendPasswordResetEmail: handleSendPasswordResetEmail,
            renderTrigger: function renderTrigger(_ref6) {
              var getTriggerProps = _ref6.getTriggerProps;
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends3.default)({}, getTriggerProps({
                  //onClick: () => setModalIsOpenTo(false),
                }), {
                  dataTestId: 'signinmodal-passwordrecoverymodal-trigger',
                  colors: 'link'
                }),
                labels.passwordrecoverymodal.subTrigger
              );
            }
          })
        ),
        _react2.default.createElement(_LoginViaThirdParty2.default, { handleSignInWithFacebook: handleSignInWithFacebook, handleSignInWithGoogle: handleSignInWithGoogle, labels: labels })
      );
    }
  }, props));
};

SignInModal.propTypes = {};
SignInModal.defaultProps = {
  onSignedIn: function onSignedIn() {
    return console.log('signed in');
  },
  handleCreateUserWithEmailAndPassword: function handleCreateUserWithEmailAndPassword(_ref7) {
    var email = _ref7.email,
        password = _ref7.password;
    return console.log('handleCreateUserWithEmailAndPassword', email, password);
  },
  handleSignInWithEmailAndPassword: function handleSignInWithEmailAndPassword(_ref8) {
    var email = _ref8.email,
        password = _ref8.password;
    return console.log('handleSignInWithEmailAndPassword', email, password);
  },
  handleSendPasswordResetEmail: function handleSendPasswordResetEmail(email) {
    return console.log('handleSendPasswordResetEmail', email);
  },
  handleSendEmailVerification: function handleSendEmailVerification(email) {
    return console.log('handleSendEmailVerification', email);
  },
  handleSignInWithFacebook: function handleSignInWithFacebook() {
    return console.log('handleSignInWithFacebook');
  },
  handleSignInWithGoogle: function handleSignInWithGoogle() {
    return console.log('handleSignInWithGoogle');
  },
  labels: {
    registeruseraccountmodal: {
      header: 'Register a new account',
      subTrigger: 'create account',
      trigger: 'register',
      submit: 'submit',
      email: 'email',
      emailRequired: 'emailRequired',
      emailInvalid: 'emailInvalid',
      password: 'password',
      passwordRequired: 'passwordRequired',
      passwordMinLength: 'passwordMinLength',
      passwordConfirmation: 'passwordConfirmation',
      passwordConfirmationRequired: 'passwordConfirmationRequired',
      passwordConfirmationMismatch: 'passwordConfirmationMismatch'
    },
    passwordrecoverymodal: {
      subTrigger: 'forgot your password?',
      trigger: 'recover your password',
      header: 'Recover your password',
      email: 'enter your email',
      submit: 'submit'
    },
    trigger: 'register',
    signinwithfacebook: 'sign in with facebook',
    signinwithgoogle: 'sign in with google',
    SignInWithEmailAndPasswordForm: {
      email: 'Email',
      password: 'Password',
      submit: 'Submit',
      emailInvalid: 'emailInvalid',
      emailRequired: 'emailRequired',
      passwordRequired: 'passwordRequired',
      passwordMinLength: 'passwordMinLength'
    }
  }
};

var enhance = (0, _recompose.compose)();

exports.default = enhance(SignInModal);