'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formik = require('formik');

var _recompose = require('recompose');

var _Form = require('./Form');

var _Form2 = _interopRequireDefault(_Form);

var _yup = require('yup');

var Yup = _interopRequireWildcard(_yup);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SignInWithEmailAndPasswordForm = function SignInWithEmailAndPasswordForm(props) {
  var labels = props.labels;

  return _react2.default.createElement(
    _Form2.default,
    (0, _extends3.default)({}, props),
    function (_ref) {
      var renderTextInputSocket = _ref.renderTextInputSocket,
          renderSubmitButton = _ref.renderSubmitButton;
      return _react2.default.createElement(
        _react.Fragment,
        null,
        renderTextInputSocket({ label: labels.email, type: 'email' }),
        renderTextInputSocket({ label: labels.password, type: 'password' }),
        renderSubmitButton({ label: labels.submit })
      );
    }
  );
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  handleSignInWithEmailAndPassword: function handleSignInWithEmailAndPassword() {
    return console.log('handleSignInWithEmailAndPassword');
  },
  labels: {
    email: 'Email',
    password: 'Password',
    submit: 'Submit',
    emailInvalid: 'emailInvalid',
    emailRequired: 'emailRequired',
    passwordRequired: 'passwordRequired',
    passwordMinLength: 'passwordMinLength'
  }
}), (0, _recompose.withProps)({
  email: '',
  password: ''
}), (0, _formik.withFormik)({
  mapPropsToValues: function mapPropsToValues(_ref2) {
    var email = _ref2.email,
        password = _ref2.password;
    return {
      email: email,
      password: password
    };
  },
  validationSchema: function validationSchema(_ref3) {
    var labels = _ref3.labels;

    return Yup.object().shape({
      email: Yup.string().email(labels.emailInvalid).required(labels.emailRequired),
      password: Yup.string().required(labels.passwordRequired).min(2, labels.passwordMinLength)
    });
  },
  handleSubmit: function handleSubmit(values, _ref4) {
    var handleSignInWithEmailAndPassword = _ref4.props.handleSignInWithEmailAndPassword,
        setSubmitting = _ref4.setSubmitting,
        setFieldError = _ref4.setFieldError;

    try {
      console.log('Submit', (0, _stringify2.default)(values, null, 2));
      handleSignInWithEmailAndPassword(values);
    } catch (e) {
      console.error(e);
      setFieldError('firebase', e.message);
    }
    setSubmitting(false);
  }
}));

exports.default = enhance(SignInWithEmailAndPasswordForm);